#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <netinet/in.h>
#include <string.h>
#include <arpa/inet.h>
#include <unistd.h>

/*

struct client_socket
    {
    	int socket;
  		struct sockaddr_in address;
        
    };

*/

int main(void) {
    char bufor[1024]; //wiadomosc
    int gniazdo, gniazdo2;
    struct sockaddr_in adr, nadawca;
    socklen_t dl = sizeof(struct sockaddr_in);
 
    gniazdo = socket(PF_INET, SOCK_STREAM, 0);
    adr.sin_family = AF_INET;
    adr.sin_port = htons(44444); //port
    adr.sin_addr.s_addr = INADDR_ANY;

    printf("Slucham na %s:%d\n", inet_ntoa(adr.sin_addr), ntohs(adr.sin_port));

    if (bind(gniazdo, (struct sockaddr*) &adr, sizeof(adr)) < 0) { //bind
        printf("Bind nie powiodl sie.\n");
        return 1;
    }
    if (listen(gniazdo, 10) < 0) { //listen
        printf("Listen nie powiodl sie.\n");
        return 1; 
    }
    printf("Czekam na polaczenie ...\n");
    while ((gniazdo2 = accept(gniazdo, (struct sockaddr*) &nadawca, &dl)) > 0) { //odbieranie
        memset(bufor, 0, 1024);
        recv(gniazdo2, bufor, 1024, 0);
        printf("Wiadomosc od %s: %s\n", inet_ntoa(nadawca.sin_addr), bufor);
        close(gniazdo2);
    }
  
	/*
    
    struct sockaddr_in adr_bind;
    struct sockaddr_in adr_accept;
    int socket_bind, socket_accept;
    char msg[1024];
    int socket_client[5];
    client_socket client;
    fd_set Clients;
    struct sockaddr_in nadawca;
    socklen_t dl = sizeof(struct sockaddr_in);
    int i;
    int j;
    
    //Inicjalizacja Tablicy Klientów
  	for(i=0; i<=4; i++)
  	{
    	client[i].socket = 0;
 	}
    
    //INICJALIZACJA SERWERA
    //Bind
    socket_bind = socket(AF_INET, SOCK_STREAM, 0);
    if(socket_bind < 0) {
    	printf("Error: Socket\n");
        return 1;
    }
    //Adres
    adr_bind.sin_family = AF_INET;
    adr_bind.sin_port = htons(44444);
    adr_bind.sin_addr.s_addr = INADDR_ANY;
    
    if (bind(socket_bind, (struct sockaddr*) &adr_bind, sizeof(adr_bind)) < 0) 
    {
        printf("Error: Bind\n");
        return 1;
    }
    
    //Listen
    if (listen(socket_bind, 10) < 0) { //listen
        printf("Error: Listen\n");
        return 1; 
    }
    
    //printf("Inicjalizacja Zakończona\n");
    
    //NASŁUCHIWANIE KLIENTÓW
    while (1) {
    	//Aktualizacja deskryptorów
    	max_fd = 0;
    	FD_ZERO(Clients);
        FD_SET(socket_bind, Clients);
        
        //Dodanie deskryptorów Klientów
        for(i =0; i<=4; i++){

            if (client[i].socket > 0) {
            	FD_SET(client[i].socket, Clients);
                if(client[i].socket > max_fd) {
                	max_fd = client[i].socket;
                }
            }
        }
        
        //Sprawdzenie Poprawności
        if(select(max_fd+1, &Clients, NULL, NULL, NULL) < 0) {
        	printf("Error: Select\n");
            close(socket_bind);
            return 0;
        }
        
        //Dodanie Klienta
        if(FD_ISSET(socket_bind, &Clients)) {
        	for(i=0;i<=4;i++){
        		if (client[i].socket == 0){
            		client[i].socket = accept(socket_bind, (struct sockaddr*) &client[i].address, &dl));
                	break;
           	 	} else {
                	printf("Server Pełen\n");
            	}
        	}
        } else {
        	printf("Error: Socket_bind nie jest w zbiorze deskryptorów");
        }
        
        //PRZETWARZANIE WIADOMOŚCI
        for(i = 0; i<=4; i++)
      	{
      		if(client[i].socket > 0 && FD_ISSET(clients[i].socket, &Clients))
      		{
        		recv(clients[i].socket, &msg, 1024, 0);
                
                //Co zrobić z wiadomością?
                if (msg == "/EXIT") {
                	for(j=0;j<=4;j++) {
                    	if(i == j && client[j].socket != 0) {
                        	close(client[i].socket);
                        	client[i].socket = 0;
                            printf("Ktoś wyszedł\n");
                        }
                    }
                } else if (msg == "/DOWNLOAD") {
                	//fork, który dostanie adres i plik i będzie zajmował się ściąganiem
                    if(fork()==0) {
                    	//send()
                    }
                } else if (msg == "/SEND"){
                	//fork, który dostanie adres i plik i będzie zajmował się wysyłaniem
                } else {
                	for(j=0;j<=4;j++) {
                    	if(i != j && client[j].socket != 0) {
                        	send(client[i].socket, &msg, 1024, 0);
                        }
                    }
                } else if (msg == "/EXIT_M" || msg == "/EXIT_M\n"){
                	for(j=0;j<=4;j++) {
                    	if(client[j].socket != 0) {
                        	close(client[i].socket);
                        	client[i].socket = 0;
                            printf("User disconnected\n");
                        }
                    }
                    printf("Koniec Serwera\n");
                    return 0;
                }
      		}
    	}
        
        
    }
    */
   
    close(gniazdo); 
    return 0; 
}